#!/usr/local/bin/ruby
#-*-Ruby-*-
# $Id: mhcmonthly1.cgi,v 1.12 1999-06-30 17:09:46+09 os Exp os $

require "web-mhc-conf"
require "WEBMHC"
require "MHC"
require "cgi-lib"
require "kconv"
include Kconv

######################################################################
### Intializations
######################################################################

$query = CGI.new

Now = Time.now
NowYear, NowMon, NowDay = Now.year, Now.mon, Now.day

if ($query['month'] =~ /^(\d\d\d\d)\/(\d\d)$/)
  year, mon = $1.to_i, $2.to_i
elsif ($query['month'] =~ /^(\d\d)$/)
  year, mon = NowYear, $1.to_i
else
  year, mon = NowYear, NowMon
end

NextTarget = "schedule"

MHCMONTHLY1_TITLE_FONT = "h1" unless (defined?(MHCMONTHLY1_TITLE_FONT))

######################################################################
### SubRoutines
######################################################################

def mkMonthlyTbl(year, mon)
  limit = days_of_month(year, mon)

  sDB = ScheduleDB.new(year, mon)
  sDB.scan(year, mon)

  yyyy = sprintf("%04d", year)
  mm = sprintf("%02d", mon)

  str = ''
  str << "<table border=1>\n"
  str << "<tr><th>date</th><th>time</th><th>schedule</th></tr>\n"
  str << "<tr><td colspan=3></td></tr>\n"

  for day in 1..limit
    d = Time::local(year, mon, day)
    ds = d.strftime("%m/%d %a")
    dd = sprintf("%02d", day)

    s = sDB.search(year, mon, day)
    ssize = s.size

    if (ssize == 0)
      str << "<tr><td><a name=#{dd}>#{ds}</a></td>"
      str << "<td><br></td><td><br></td></tr>\n"
    else
      for i in 0..ssize - 1
	path = substrPath(s[i].path)
	if (i == 0)
	  str << "<tr><td><a name=#{dd}>#{ds}</a></td>"
	else
	  str << "<tr><td><br></td>"
	end

	str << "<td>#{s[i].tim_s}-#{s[i].tim_e}</td>"
	str << "<td><a href=\"#{MHCCAT}?file=#{path}&amp;type=html\""
	str << " target=\"#{NextTarget}\">#{s[i].sub}</a></td></tr>\n"
      end
    end
  end

  str << "</table>\n"

  str
end

######################################################################
### Main
######################################################################

py, pm = getPrevMonth(year, mon)
ny, nm = getNextMonth(year, mon)

theMonth = getMonthStr(year, mon)
prevMonth = getMonthStr(py, pm)
nextMonth = getMonthStr(ny, nm)

print "Content-Type: text/html\n"
print "\n"

print <<EOH
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html lang=ja>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-2022-JP">
<title>MHC Monthly Index (#{theMonth})</title>
</head>

EOH

print "<body>\n"

if (defined?(MHCMONTHLY1_TITLE) && MHCMONTHLY1_TITLE != '')
  print "\n<#{MHCMONTHLY1_TITLE_FONT}>"
  print "#{tojis(MHCMONTHLY1_TITLE)}"
  print "</#{MHCMONTHLY1_TITLE_FONT}>\n"
end

print <<EOT

<table width="100%"><tr>

<td align=left>
[<a href="#{MHCMONTHLY1}?month=#{prevMonth}">#{prevMonth}</a>]
&lt;&lt;
[#{theMonth}]
&gt;&gt;
[<a href="#{MHCMONTHLY1}?month=#{nextMonth}">#{nextMonth}</a>]
</td>

<td align=right>
<a href="#{MAIN}?duration=3" target="_top">3 months index</a>
</td>

</tr></table>

EOT

tbl = mkMonthlyTbl(year, mon)
print tbl

print <<EOT

</body>
</html>
EOT

exit 0
